from typing import Any, Dict, List, Type, TypeVar, Union

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..models.interface_rf_channel_label import InterfaceRfChannelLabel
from ..models.interface_rf_channel_value import InterfaceRfChannelValue
from ..types import UNSET, Unset

T = TypeVar("T", bound="InterfaceRfChannel")


@_attrs_define
class InterfaceRfChannel:
    """
    Attributes:
        value (Union[Unset, InterfaceRfChannelValue]): * `2.4g-1-2412-22` - 1 (2412 MHz)
            * `2.4g-2-2417-22` - 2 (2417 MHz)
            * `2.4g-3-2422-22` - 3 (2422 MHz)
            * `2.4g-4-2427-22` - 4 (2427 MHz)
            * `2.4g-5-2432-22` - 5 (2432 MHz)
            * `2.4g-6-2437-22` - 6 (2437 MHz)
            * `2.4g-7-2442-22` - 7 (2442 MHz)
            * `2.4g-8-2447-22` - 8 (2447 MHz)
            * `2.4g-9-2452-22` - 9 (2452 MHz)
            * `2.4g-10-2457-22` - 10 (2457 MHz)
            * `2.4g-11-2462-22` - 11 (2462 MHz)
            * `2.4g-12-2467-22` - 12 (2467 MHz)
            * `2.4g-13-2472-22` - 13 (2472 MHz)
            * `5g-32-5160-20` - 32 (5160/20 MHz)
            * `5g-34-5170-40` - 34 (5170/40 MHz)
            * `5g-36-5180-20` - 36 (5180/20 MHz)
            * `5g-38-5190-40` - 38 (5190/40 MHz)
            * `5g-40-5200-20` - 40 (5200/20 MHz)
            * `5g-42-5210-80` - 42 (5210/80 MHz)
            * `5g-44-5220-20` - 44 (5220/20 MHz)
            * `5g-46-5230-40` - 46 (5230/40 MHz)
            * `5g-48-5240-20` - 48 (5240/20 MHz)
            * `5g-50-5250-160` - 50 (5250/160 MHz)
            * `5g-52-5260-20` - 52 (5260/20 MHz)
            * `5g-54-5270-40` - 54 (5270/40 MHz)
            * `5g-56-5280-20` - 56 (5280/20 MHz)
            * `5g-58-5290-80` - 58 (5290/80 MHz)
            * `5g-60-5300-20` - 60 (5300/20 MHz)
            * `5g-62-5310-40` - 62 (5310/40 MHz)
            * `5g-64-5320-20` - 64 (5320/20 MHz)
            * `5g-100-5500-20` - 100 (5500/20 MHz)
            * `5g-102-5510-40` - 102 (5510/40 MHz)
            * `5g-104-5520-20` - 104 (5520/20 MHz)
            * `5g-106-5530-80` - 106 (5530/80 MHz)
            * `5g-108-5540-20` - 108 (5540/20 MHz)
            * `5g-110-5550-40` - 110 (5550/40 MHz)
            * `5g-112-5560-20` - 112 (5560/20 MHz)
            * `5g-114-5570-160` - 114 (5570/160 MHz)
            * `5g-116-5580-20` - 116 (5580/20 MHz)
            * `5g-118-5590-40` - 118 (5590/40 MHz)
            * `5g-120-5600-20` - 120 (5600/20 MHz)
            * `5g-122-5610-80` - 122 (5610/80 MHz)
            * `5g-124-5620-20` - 124 (5620/20 MHz)
            * `5g-126-5630-40` - 126 (5630/40 MHz)
            * `5g-128-5640-20` - 128 (5640/20 MHz)
            * `5g-132-5660-20` - 132 (5660/20 MHz)
            * `5g-134-5670-40` - 134 (5670/40 MHz)
            * `5g-136-5680-20` - 136 (5680/20 MHz)
            * `5g-138-5690-80` - 138 (5690/80 MHz)
            * `5g-140-5700-20` - 140 (5700/20 MHz)
            * `5g-142-5710-40` - 142 (5710/40 MHz)
            * `5g-144-5720-20` - 144 (5720/20 MHz)
            * `5g-149-5745-20` - 149 (5745/20 MHz)
            * `5g-151-5755-40` - 151 (5755/40 MHz)
            * `5g-153-5765-20` - 153 (5765/20 MHz)
            * `5g-155-5775-80` - 155 (5775/80 MHz)
            * `5g-157-5785-20` - 157 (5785/20 MHz)
            * `5g-159-5795-40` - 159 (5795/40 MHz)
            * `5g-161-5805-20` - 161 (5805/20 MHz)
            * `5g-163-5815-160` - 163 (5815/160 MHz)
            * `5g-165-5825-20` - 165 (5825/20 MHz)
            * `5g-167-5835-40` - 167 (5835/40 MHz)
            * `5g-169-5845-20` - 169 (5845/20 MHz)
            * `5g-171-5855-80` - 171 (5855/80 MHz)
            * `5g-173-5865-20` - 173 (5865/20 MHz)
            * `5g-175-5875-40` - 175 (5875/40 MHz)
            * `5g-177-5885-20` - 177 (5885/20 MHz)
            * `6g-1-5955-20` - 1 (5955/20 MHz)
            * `6g-3-5965-40` - 3 (5965/40 MHz)
            * `6g-5-5975-20` - 5 (5975/20 MHz)
            * `6g-7-5985-80` - 7 (5985/80 MHz)
            * `6g-9-5995-20` - 9 (5995/20 MHz)
            * `6g-11-6005-40` - 11 (6005/40 MHz)
            * `6g-13-6015-20` - 13 (6015/20 MHz)
            * `6g-15-6025-160` - 15 (6025/160 MHz)
            * `6g-17-6035-20` - 17 (6035/20 MHz)
            * `6g-19-6045-40` - 19 (6045/40 MHz)
            * `6g-21-6055-20` - 21 (6055/20 MHz)
            * `6g-23-6065-80` - 23 (6065/80 MHz)
            * `6g-25-6075-20` - 25 (6075/20 MHz)
            * `6g-27-6085-40` - 27 (6085/40 MHz)
            * `6g-29-6095-20` - 29 (6095/20 MHz)
            * `6g-31-6105-320` - 31 (6105/320 MHz)
            * `6g-33-6115-20` - 33 (6115/20 MHz)
            * `6g-35-6125-40` - 35 (6125/40 MHz)
            * `6g-37-6135-20` - 37 (6135/20 MHz)
            * `6g-39-6145-80` - 39 (6145/80 MHz)
            * `6g-41-6155-20` - 41 (6155/20 MHz)
            * `6g-43-6165-40` - 43 (6165/40 MHz)
            * `6g-45-6175-20` - 45 (6175/20 MHz)
            * `6g-47-6185-160` - 47 (6185/160 MHz)
            * `6g-49-6195-20` - 49 (6195/20 MHz)
            * `6g-51-6205-40` - 51 (6205/40 MHz)
            * `6g-53-6215-20` - 53 (6215/20 MHz)
            * `6g-55-6225-80` - 55 (6225/80 MHz)
            * `6g-57-6235-20` - 57 (6235/20 MHz)
            * `6g-59-6245-40` - 59 (6245/40 MHz)
            * `6g-61-6255-20` - 61 (6255/20 MHz)
            * `6g-65-6275-20` - 65 (6275/20 MHz)
            * `6g-67-6285-40` - 67 (6285/40 MHz)
            * `6g-69-6295-20` - 69 (6295/20 MHz)
            * `6g-71-6305-80` - 71 (6305/80 MHz)
            * `6g-73-6315-20` - 73 (6315/20 MHz)
            * `6g-75-6325-40` - 75 (6325/40 MHz)
            * `6g-77-6335-20` - 77 (6335/20 MHz)
            * `6g-79-6345-160` - 79 (6345/160 MHz)
            * `6g-81-6355-20` - 81 (6355/20 MHz)
            * `6g-83-6365-40` - 83 (6365/40 MHz)
            * `6g-85-6375-20` - 85 (6375/20 MHz)
            * `6g-87-6385-80` - 87 (6385/80 MHz)
            * `6g-89-6395-20` - 89 (6395/20 MHz)
            * `6g-91-6405-40` - 91 (6405/40 MHz)
            * `6g-93-6415-20` - 93 (6415/20 MHz)
            * `6g-95-6425-320` - 95 (6425/320 MHz)
            * `6g-97-6435-20` - 97 (6435/20 MHz)
            * `6g-99-6445-40` - 99 (6445/40 MHz)
            * `6g-101-6455-20` - 101 (6455/20 MHz)
            * `6g-103-6465-80` - 103 (6465/80 MHz)
            * `6g-105-6475-20` - 105 (6475/20 MHz)
            * `6g-107-6485-40` - 107 (6485/40 MHz)
            * `6g-109-6495-20` - 109 (6495/20 MHz)
            * `6g-111-6505-160` - 111 (6505/160 MHz)
            * `6g-113-6515-20` - 113 (6515/20 MHz)
            * `6g-115-6525-40` - 115 (6525/40 MHz)
            * `6g-117-6535-20` - 117 (6535/20 MHz)
            * `6g-119-6545-80` - 119 (6545/80 MHz)
            * `6g-121-6555-20` - 121 (6555/20 MHz)
            * `6g-123-6565-40` - 123 (6565/40 MHz)
            * `6g-125-6575-20` - 125 (6575/20 MHz)
            * `6g-129-6595-20` - 129 (6595/20 MHz)
            * `6g-131-6605-40` - 131 (6605/40 MHz)
            * `6g-133-6615-20` - 133 (6615/20 MHz)
            * `6g-135-6625-80` - 135 (6625/80 MHz)
            * `6g-137-6635-20` - 137 (6635/20 MHz)
            * `6g-139-6645-40` - 139 (6645/40 MHz)
            * `6g-141-6655-20` - 141 (6655/20 MHz)
            * `6g-143-6665-160` - 143 (6665/160 MHz)
            * `6g-145-6675-20` - 145 (6675/20 MHz)
            * `6g-147-6685-40` - 147 (6685/40 MHz)
            * `6g-149-6695-20` - 149 (6695/20 MHz)
            * `6g-151-6705-80` - 151 (6705/80 MHz)
            * `6g-153-6715-20` - 153 (6715/20 MHz)
            * `6g-155-6725-40` - 155 (6725/40 MHz)
            * `6g-157-6735-20` - 157 (6735/20 MHz)
            * `6g-159-6745-320` - 159 (6745/320 MHz)
            * `6g-161-6755-20` - 161 (6755/20 MHz)
            * `6g-163-6765-40` - 163 (6765/40 MHz)
            * `6g-165-6775-20` - 165 (6775/20 MHz)
            * `6g-167-6785-80` - 167 (6785/80 MHz)
            * `6g-169-6795-20` - 169 (6795/20 MHz)
            * `6g-171-6805-40` - 171 (6805/40 MHz)
            * `6g-173-6815-20` - 173 (6815/20 MHz)
            * `6g-175-6825-160` - 175 (6825/160 MHz)
            * `6g-177-6835-20` - 177 (6835/20 MHz)
            * `6g-179-6845-40` - 179 (6845/40 MHz)
            * `6g-181-6855-20` - 181 (6855/20 MHz)
            * `6g-183-6865-80` - 183 (6865/80 MHz)
            * `6g-185-6875-20` - 185 (6875/20 MHz)
            * `6g-187-6885-40` - 187 (6885/40 MHz)
            * `6g-189-6895-20` - 189 (6895/20 MHz)
            * `6g-193-6915-20` - 193 (6915/20 MHz)
            * `6g-195-6925-40` - 195 (6925/40 MHz)
            * `6g-197-6935-20` - 197 (6935/20 MHz)
            * `6g-199-6945-80` - 199 (6945/80 MHz)
            * `6g-201-6955-20` - 201 (6955/20 MHz)
            * `6g-203-6965-40` - 203 (6965/40 MHz)
            * `6g-205-6975-20` - 205 (6975/20 MHz)
            * `6g-207-6985-160` - 207 (6985/160 MHz)
            * `6g-209-6995-20` - 209 (6995/20 MHz)
            * `6g-211-7005-40` - 211 (7005/40 MHz)
            * `6g-213-7015-20` - 213 (7015/20 MHz)
            * `6g-215-7025-80` - 215 (7025/80 MHz)
            * `6g-217-7035-20` - 217 (7035/20 MHz)
            * `6g-219-7045-40` - 219 (7045/40 MHz)
            * `6g-221-7055-20` - 221 (7055/20 MHz)
            * `6g-225-7075-20` - 225 (7075/20 MHz)
            * `6g-227-7085-40` - 227 (7085/40 MHz)
            * `6g-229-7095-20` - 229 (7095/20 MHz)
            * `6g-233-7115-20` - 233 (7115/20 MHz)
            * `60g-1-58320-2160` - 1 (58.32/2.16 GHz)
            * `60g-2-60480-2160` - 2 (60.48/2.16 GHz)
            * `60g-3-62640-2160` - 3 (62.64/2.16 GHz)
            * `60g-4-64800-2160` - 4 (64.80/2.16 GHz)
            * `60g-5-66960-2160` - 5 (66.96/2.16 GHz)
            * `60g-6-69120-2160` - 6 (69.12/2.16 GHz)
            * `60g-9-59400-4320` - 9 (59.40/4.32 GHz)
            * `60g-10-61560-4320` - 10 (61.56/4.32 GHz)
            * `60g-11-63720-4320` - 11 (63.72/4.32 GHz)
            * `60g-12-65880-4320` - 12 (65.88/4.32 GHz)
            * `60g-13-68040-4320` - 13 (68.04/4.32 GHz)
            * `60g-17-60480-6480` - 17 (60.48/6.48 GHz)
            * `60g-18-62640-6480` - 18 (62.64/6.48 GHz)
            * `60g-19-64800-6480` - 19 (64.80/6.48 GHz)
            * `60g-20-66960-6480` - 20 (66.96/6.48 GHz)
            * `60g-25-61560-6480` - 25 (61.56/8.64 GHz)
            * `60g-26-63720-6480` - 26 (63.72/8.64 GHz)
            * `60g-27-65880-6480` - 27 (65.88/8.64 GHz)
        label (Union[Unset, InterfaceRfChannelLabel]):
    """

    value: Union[Unset, InterfaceRfChannelValue] = UNSET
    label: Union[Unset, InterfaceRfChannelLabel] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        value: Union[Unset, str] = UNSET
        if not isinstance(self.value, Unset):
            value = self.value.value

        label: Union[Unset, str] = UNSET
        if not isinstance(self.label, Unset):
            label = self.label.value

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if value is not UNSET:
            field_dict["value"] = value
        if label is not UNSET:
            field_dict["label"] = label

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        _value = d.pop("value", UNSET)
        value: Union[Unset, InterfaceRfChannelValue]
        if isinstance(_value, Unset):
            value = UNSET
        else:
            value = InterfaceRfChannelValue(_value)

        _label = d.pop("label", UNSET)
        label: Union[Unset, InterfaceRfChannelLabel]
        if isinstance(_label, Unset):
            label = UNSET
        else:
            label = InterfaceRfChannelLabel(_label)

        interface_rf_channel = cls(
            value=value,
            label=label,
        )

        interface_rf_channel.additional_properties = d
        return interface_rf_channel

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
